import '../../../../node_modules/core-js/modules/es.object.to-string.js';
import '../../../../node_modules/core-js/modules/es.reflect.construct.js';
import '../../../../node_modules/core-js/modules/es.regexp.to-string.js';
import classCallCheck from '../../../../node_modules/@babel/runtime/helpers/classCallCheck.js';
import createClass from '../../../../node_modules/@babel/runtime/helpers/createClass.js';
import inherits from '../../../../node_modules/@babel/runtime/helpers/inherits.js';
import possibleConstructorReturn from '../../../../node_modules/@babel/runtime/helpers/possibleConstructorReturn.js';
import getPrototypeOf from '../../../../node_modules/@babel/runtime/helpers/getPrototypeOf.js';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import BaseComponent from '../../BaseComponent.js';
import '../../../../node_modules/core-js/modules/es.array.map.js';
import '../DetailsColumn/DetailsColumn.base.js';
import { DetailsColumn } from '../DetailsColumn/DetailsColumn.js';

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction();

var DetailsHeaderBase = /*#__PURE__*/function (_BaseComponent) {
  inherits(DetailsHeaderBase, _BaseComponent);

  var _super = _createSuper(DetailsHeaderBase);

  function DetailsHeaderBase() {
    classCallCheck(this, DetailsHeaderBase);

    return _super.apply(this, arguments);
  }

  createClass(DetailsHeaderBase, [{
    key: "render",
    value: function render() {
      var _this = this;

      var h = arguments[0];
      var classNames = this.classNames,
          columns = this.columns;
      return h("div", {
        "class": classNames.root,
        "attrs": {
          "role": "row"
        }
      }, [columns.map(function (column, index) {
        return h(DetailsColumn, {
          "key": column.key,
          "attrs": {
            "column": column,
            "columnIndex": index,
            "parentId": _this.uid
          }
        });
      })]);
    }
  }, {
    key: "classNames",
    get: function get() {
      var styles = this.styles,
          theme = this.theme,
          className = this.className;
      return getClassNames(styles, {
        theme: theme,
        isAllSelected: false,
        isSelectAllHidden: false,
        isResizingColumn: false,
        isSizing: false,
        isAllCollapsed: false,
        isCheckboxHidden: false,
        className: className
      });
    }
  }]);

  return DetailsHeaderBase;
}(BaseComponent);

__decorate([Prop({
  type: Array,
  required: true
}), __metadata("design:type", Array)], DetailsHeaderBase.prototype, "columns", void 0);

DetailsHeaderBase = __decorate([Component({
  components: {
    DetailsColumn: DetailsColumn
  }
})], DetailsHeaderBase);

export { DetailsHeaderBase };
