import '../../../node_modules/core-js/modules/es.object.to-string.js';
import '../../../node_modules/core-js/modules/es.reflect.construct.js';
import '../../../node_modules/core-js/modules/es.regexp.to-string.js';
import classCallCheck from '../../../node_modules/@babel/runtime/helpers/classCallCheck.js';
import createClass from '../../../node_modules/@babel/runtime/helpers/createClass.js';
import inherits from '../../../node_modules/@babel/runtime/helpers/inherits.js';
import possibleConstructorReturn from '../../../node_modules/@babel/runtime/helpers/possibleConstructorReturn.js';
import getPrototypeOf from '../../../node_modules/@babel/runtime/helpers/getPrototypeOf.js';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import StatelessComponent from '../StatelessComponent.js';
import helper from '../../../node_modules/@vue/babel-helper-vue-jsx-merge-props/dist/helper.js';

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction({
  disableCaching: true
});

var LabelBase = /*#__PURE__*/function (_StatelessComponent) {
  inherits(LabelBase, _StatelessComponent);

  var _super = _createSuper(LabelBase);

  function LabelBase() {
    classCallCheck(this, LabelBase);

    return _super.apply(this, arguments);
  }

  createClass(LabelBase, [{
    key: "render",
    value: function render(h, context) {
      var _context$props = context.props,
          theme = _context$props.theme,
          className = _context$props.className,
          disabled = _context$props.disabled,
          required = _context$props.required;
      var classNames = getClassNames(context.props.styles, {
        className: className,
        disabled: disabled,
        required: required,
        theme: theme
      });
      return h("label", helper([{
        "class": classNames.root
      }, context.data]), [context.children]);
    }
  }]);

  return LabelBase;
}(StatelessComponent);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], LabelBase.prototype, "disabled", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], LabelBase.prototype, "required", void 0);

LabelBase = __decorate([Component], LabelBase);

export { LabelBase };
