import '../../../../node_modules/core-js/modules/es.object.to-string.js';
import '../../../../node_modules/core-js/modules/es.reflect.construct.js';
import '../../../../node_modules/core-js/modules/es.regexp.to-string.js';
import classCallCheck from '../../../../node_modules/@babel/runtime/helpers/classCallCheck.js';
import createClass from '../../../../node_modules/@babel/runtime/helpers/createClass.js';
import inherits from '../../../../node_modules/@babel/runtime/helpers/inherits.js';
import possibleConstructorReturn from '../../../../node_modules/@babel/runtime/helpers/possibleConstructorReturn.js';
import getPrototypeOf from '../../../../node_modules/@babel/runtime/helpers/getPrototypeOf.js';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import BaseComponent from '../../BaseComponent.js';
import '../../../../node_modules/core-js/modules/es.symbol.js';
import '../../../../node_modules/core-js/modules/es.array.filter.js';
import '../../../../node_modules/core-js/modules/es.array.for-each.js';
import '../../../../node_modules/core-js/modules/es.object.get-own-property-descriptor.js';
import '../../../../node_modules/core-js/modules/es.object.get-own-property-descriptors.js';
import '../../../../node_modules/core-js/modules/es.object.keys.js';
import '../../../../node_modules/core-js/modules/web.dom-collections.for-each.js';
import defineProperty from '../../../../node_modules/@babel/runtime/helpers/defineProperty.js';
import { BaseButton } from '../BaseButton.js';
import { getStyles } from './DefaultButton.styles.js';

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var DefaultButton = /*#__PURE__*/function (_BaseComponent) {
  inherits(DefaultButton, _BaseComponent);

  var _super = _createSuper(DefaultButton);

  function DefaultButton() {
    classCallCheck(this, DefaultButton);

    return _super.apply(this, arguments);
  }

  createClass(DefaultButton, [{
    key: "render",
    value: function render() {
      var h = arguments[0];
      var primary = this.primary,
          internalStyles = this.internalStyles;

      var props = _objectSpread(_objectSpread({}, this.$props), {}, {
        variantClassName: primary ? 'ms-Button--primary' : 'ms-Button--default',
        styles: internalStyles
      });

      return h(BaseButton, {
        "props": _objectSpread({}, props),
        "attrs": _objectSpread({}, this.$attrs)
      }, [this.$slots.default]);
    }
  }, {
    key: "internalStyles",
    get: function get() {
      var _this$primary = this.primary,
          primary = _this$primary === void 0 ? false : _this$primary,
          theme = this.theme;
      return getStyles(theme, this.styles, primary);
    }
  }]);

  return DefaultButton;
}(BaseComponent);

__decorate([Prop({
  type: String,
  default: ''
}), __metadata("design:type", String)], DefaultButton.prototype, "text", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], DefaultButton.prototype, "primary", void 0);

__decorate([Prop({
  type: Boolean,
  default: false
}), __metadata("design:type", Boolean)], DefaultButton.prototype, "disabled", void 0);

DefaultButton = __decorate([Component], DefaultButton);

export { DefaultButton };
