import '../../node_modules/core-js/modules/es.object.to-string.js';
import '../../node_modules/core-js/modules/es.reflect.construct.js';
import '../../node_modules/core-js/modules/es.regexp.to-string.js';
import classCallCheck from '../../node_modules/@babel/runtime/helpers/classCallCheck.js';
import createClass from '../../node_modules/@babel/runtime/helpers/createClass.js';
import inherits from '../../node_modules/@babel/runtime/helpers/inherits.js';
import possibleConstructorReturn from '../../node_modules/@babel/runtime/helpers/possibleConstructorReturn.js';
import getPrototypeOf from '../../node_modules/@babel/runtime/helpers/getPrototypeOf.js';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import Vue from 'vue';
import '../../node_modules/core-js/modules/es.number.constructor.js';

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var DelayedRender = /*#__PURE__*/function (_Vue) {
  inherits(DelayedRender, _Vue);

  var _super = _createSuper(DelayedRender);

  function DelayedRender() {
    var _this;

    classCallCheck(this, DelayedRender);

    _this = _super.apply(this, arguments);
    _this.isRendered = false;
    return _this;
  }

  createClass(DelayedRender, [{
    key: "mounted",
    value: function mounted() {
      var _this2 = this;

      this.timeoutId = setTimeout(function () {
        _this2.isRendered = true;
      }, this.delay);
    }
  }, {
    key: "beforeDestroy",
    value: function beforeDestroy() {
      if (this.timeoutId) clearTimeout(this.timeoutId);
    }
  }, {
    key: "render",
    value: function render() {
      var h = arguments[0];
      return this.isRendered ? h("div", [this.$slots.default]) : null;
    }
  }]);

  return DelayedRender;
}(Vue);

__decorate([Prop({
  type: Number,
  default: 0
}), __metadata("design:type", Number)], DelayedRender.prototype, "delay", void 0);

DelayedRender = __decorate([Component], DelayedRender);

export { DelayedRender };
