import '../../../../node_modules/core-js/modules/es.object.to-string.js';
import '../../../../node_modules/core-js/modules/es.reflect.construct.js';
import '../../../../node_modules/core-js/modules/es.regexp.to-string.js';
import classCallCheck from '../../../../node_modules/@babel/runtime/helpers/classCallCheck.js';
import createClass from '../../../../node_modules/@babel/runtime/helpers/createClass.js';
import inherits from '../../../../node_modules/@babel/runtime/helpers/inherits.js';
import possibleConstructorReturn from '../../../../node_modules/@babel/runtime/helpers/possibleConstructorReturn.js';
import getPrototypeOf from '../../../../node_modules/@babel/runtime/helpers/getPrototypeOf.js';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { classNamesFunction } from '@uifabric-vue/utilities';
import { mergeStyleSets, getTheme } from '@uifabric/styling';
import StatelessComponent from '../../StatelessComponent.js';
import '../../../../node_modules/core-js/modules/es.number.constructor.js';
import { StackItemStyles } from './StackItem.styles.js';

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }
var getClassNames = classNamesFunction({
  disableCaching: true
});

var StackItem = /*#__PURE__*/function (_StatelessComponent) {
  inherits(StackItem, _StatelessComponent);

  var _super = _createSuper(StackItem);

  function StackItem() {
    classCallCheck(this, StackItem);

    return _super.apply(this, arguments);
  }

  createClass(StackItem, [{
    key: "render",
    value: function render(h, context) {
      var _context$props = context.props,
          grow = _context$props.grow,
          shrink = _context$props.shrink,
          disableShrink = _context$props.disableShrink,
          align = _context$props.align,
          verticalFill = _context$props.verticalFill,
          order = _context$props.order,
          className = _context$props.className,
          styles = _context$props.styles;
      var classNames = getClassNames(mergeStyleSets(StackItemStyles({
        grow: grow,
        shrink: shrink,
        disableShrink: disableShrink,
        align: align,
        verticalFill: verticalFill,
        order: order,
        className: className
      }, getTheme(), {}), styles));
      return h("div", {
        "class": classNames.root
      }, [context.children]);
    }
  }]);

  return StackItem;
}(StatelessComponent);

__decorate([Prop({
  type: [Number, Boolean],
  default: 0
}), __metadata("design:type", Object)], StackItem.prototype, "grow", void 0);

__decorate([Prop(), __metadata("design:type", Object)], StackItem.prototype, "shrink", void 0);

__decorate([Prop(), __metadata("design:type", Object)], StackItem.prototype, "disableShrink", void 0);

__decorate([Prop(), __metadata("design:type", Object)], StackItem.prototype, "align", void 0);

__decorate([Prop(), __metadata("design:type", Object)], StackItem.prototype, "verticalFill", void 0);

__decorate([Prop({
  type: Number,
  default: null
}), __metadata("design:type", Number)], StackItem.prototype, "order", void 0);

__decorate([Prop({
  type: Number,
  default: 0
}), __metadata("design:type", Number)], StackItem.prototype, "test", void 0);

StackItem = __decorate([Component({
  components: {}
})], StackItem);
var StackItem$1 = StackItem;

export default StackItem$1;
