import '../../../node_modules/core-js/modules/es.object.to-string.js';
import '../../../node_modules/core-js/modules/es.reflect.construct.js';
import '../../../node_modules/core-js/modules/es.regexp.to-string.js';
import classCallCheck from '../../../node_modules/@babel/runtime/helpers/classCallCheck.js';
import createClass from '../../../node_modules/@babel/runtime/helpers/createClass.js';
import inherits from '../../../node_modules/@babel/runtime/helpers/inherits.js';
import possibleConstructorReturn from '../../../node_modules/@babel/runtime/helpers/possibleConstructorReturn.js';
import getPrototypeOf from '../../../node_modules/@babel/runtime/helpers/getPrototypeOf.js';
import { __decorate, __metadata } from 'tslib';
import { Prop, Component } from 'vue-property-decorator';
import { css } from '@uifabric-vue/utilities';
import BaseComponent from '../../components/BaseComponent.js';
import defineProperty from '../../../node_modules/@babel/runtime/helpers/defineProperty.js';
import helper from '../../../node_modules/@vue/babel-helper-vue-jsx-merge-props/dist/helper.js';
import '../../components/Button/BaseButton.js';
import { ActionButton } from '../../components/Button/ActionButton/ActionButton.js';
import '../../components/Button/DefaultButton/DefaultButton.js';
import '../../components/Button/PrimaryButton/PrimaryButton.js';
import '../../components/Button/CommandBarButton/CommandBarButton.js';
import '../../components/Button/CompoundButton/CompoundButton.js';
import '../../components/Button/IconButton/IconButton.js';
import '../../components/Button/MessageBarButton/MessageBarButton.js';

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return possibleConstructorReturn(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Date.prototype.toString.call(Reflect.construct(Date, [], function () {})); return true; } catch (e) { return false; } }

var GridCell = /*#__PURE__*/function (_BaseComponent) {
  inherits(GridCell, _BaseComponent);

  var _super = _createSuper(GridCell);

  function GridCell() {
    classCallCheck(this, GridCell);

    return _super.apply(this, arguments);
  }

  createClass(GridCell, [{
    key: "render",
    value: function render() {
      var _css;

      var h = arguments[0];
      var className = this.className,
          item = this.item,
          cellDisabledStyle = this.cellDisabledStyle,
          cellIsSelectedStyle = this.cellIsSelectedStyle,
          selected = this.selected,
          disabled = this.disabled;
      return h(ActionButton, helper([{
        "class": css(className, (_css = {}, defineProperty(_css, '' + cellIsSelectedStyle, selected), defineProperty(_css, '' + cellDisabledStyle, disabled), _css)),
        "attrs": {
          "getClassNames": this.getClassNames
        }
      }, {
        scopedSlots: {
          flex: this.$scopedSlots.default
        }
      }]));
    }
  }]);

  return GridCell;
}(BaseComponent);

__decorate([Prop({
  type: Object,
  default: function _default() {}
}), __metadata("design:type", Object)], GridCell.prototype, "item", void 0);

__decorate([Prop({
  type: Boolean
}), __metadata("design:type", Boolean)], GridCell.prototype, "disabled", void 0);

__decorate([Prop({
  type: Boolean
}), __metadata("design:type", Boolean)], GridCell.prototype, "selected", void 0);

__decorate([Prop({
  type: String
}), __metadata("design:type", String)], GridCell.prototype, "cellDisabledStyle", void 0);

__decorate([Prop({
  type: String
}), __metadata("design:type", String)], GridCell.prototype, "cellIsSelectedStyle", void 0);

__decorate([Prop(), __metadata("design:type", Object)], GridCell.prototype, "getClassNames", void 0);

GridCell = __decorate([Component({
  components: {
    ActionButton: ActionButton
  }
})], GridCell);

export { GridCell };
